/*
 * Fresnel.java
 *
 * Created on 6 de junio de 2003, 3:54
 */

/**
 *
 * @author  Marcelo Soto
 */

import java.util.SortedMap;
import java.util.TreeMap;
import java.util.Vector;
public class CFresnel {
    
    /** Creates a new instance of Frenel */
    public CFresnel() {    
        
    }
    
    public CFresnel(RadioLink antenas, TopoProfile perfil, float frec) /* f [MHz]*/
    {
        Antenas = new RadioLink();
        Perfil = new  TopoProfile();
        UEllipse = new TreeMap();
		LEllipse = new TreeMap();
        frecuencia=frec;
                        
        Antenas =(RadioLink) antenas.clone();
        Perfil = (TopoProfile) perfil.clone();
        xA = 1000*((Float) Antenas.firstKeyC()).floatValue();
        yA = ((Float) Antenas.getC((Float)Antenas.firstKeyC())).floatValue();
        xB = 1000*((Float) Antenas.lastKeyC()).floatValue();
        yB = ((Float) Antenas.getC((Float)Antenas.lastKeyC())).floatValue();
        
        recta = new Recta(xA,yA,xB,yB);
        setLambda(frecuencia);
        
    }       
    
    public void setLambda(float frec){frecuencia=frec;lambda = 300000/frecuencia;}
    
    public void Calculo() 
    {   
        P_Inicio = -5;              // Valor fuera del Rango de inters
        Float floater = new Float(0);
        String stringer = new String();
        Ellipse = new TreeMap();
        //SortedSet X = Collections.synchronizedSortedSet(new TreeSet()); 
        Vector VX =new Vector(); 
        float xpA,ypA;
        xpA=xA;ypA=yA;
       // X=(TreeSet) Perfil.keySetC();
       // boolean dummy = VX.addAll(X);
        VX = Perfil.keySetVC();
        
        int i =VX.indexOf(VX.firstElement()) +1;
                      
        boolean obstActual = false;
        boolean obstAnterior = false;
        
        while (i<VX.size())
        {
            float xp = ((Float)(VX.elementAt(i))).floatValue();;
	    	float yp = ((Float)(Perfil.getC(VX.elementAt(i)))).floatValue();
            
            float yr  = recta.get_y(xp);
          
            
            if ((xp>=xA) && (xp<=xB) )       // Solo se hacen los clculos entre las Antenas
            {
                float radio = Radio(xp, yr);
                obstActual=false;
                
                SimpleComplex Upper = new SimpleComplex(); 
				SimpleComplex Lower = new SimpleComplex();
				
				Upper = this.UpperPoint(radio,recta,xp);
				Lower = this.LowerPoint(radio,recta,xp);
				
				UEllipse.put(new Float(Upper.getReal()),new Float(Upper.getIm()));
				LEllipse.put(new Float(Lower.getReal()),new Float(Lower.getIm()));
				
                /*Vector  Y = new Vector(2);
                Y.add(0,Float.valueOf(String.valueOf(yr+radio)));
                Y.add(1,Float.valueOf(String.valueOf(yr-radio)));
                Ellipse.put(Float.valueOf(String.valueOf(xp)),Y);*/
                
                if(Lower.getIm()<yp) obstActual=true;
            
                if ((obstActual)&&(!obstAnterior)) 
                {
                    P_Inicio=xp;
                    Inicio(xpA, ypA, xp, yp);
                }
            
                if ((!obstActual)&&(obstAnterior))
                {
                    P_Fin=xp;
                    Fin(xpA, ypA, xp, yp);
                }
            
                obstAnterior=obstActual;
                xpA=xp;                         // xpA y xpB Almacenan los valores del punto actual
                ypA=yp;                         // para ser utilizados en la siguiente iteracion
                                                // como un punto anterior
                Obst.clear();
                if (P_Inicio!=-5) Obstruct();
            }                                   
        }
    }
    
    private float Radio(float x, float y)
    {   ///
        float d1 =(float) Math.sqrt(Math.pow((x-xA),2)+(Math.pow((y-yB),2)));
        float d2 = (float) Math.sqrt(Math.pow((x-xB),2)+(Math.pow((y-yB),2)));
        /////
        return ((float) Math.sqrt((lambda*d1*d2)/(d1+d2)));
    }  // LAMBDA ///
    
    private void Inicio(float xAnterior, float yAnterior, float xActual, float yActual)
    {    
        float x= (xActual-xAnterior)/2;
        float y= (yActual-yAnterior)/2;
        float yr = recta.get_y(x);    
        float radio = Radio(x,yr);
        xInicial = x;
        yInicial = y;
        float Precision=(float) Math.abs((long) (((x-xActual)/xActual)*100));    // Porcentaje de precisin
        if(((yr-radio)<=y) && (Precision>1)) Inicio(xAnterior,yAnterior,x,y);   // Hasta que la precisin    
        if(((yr-radio)>y) && (Precision>1)) Inicio(x,y,xActual,yActual);        // sea 1%
    
    }  
    private void Fin(float xAnterior, float yAnterior, float xActual, float yActual)
    {
               
        float x= (xActual-xAnterior)/2;
        float y= (yActual-yAnterior)/2;
        float yr = recta.get_y(x); 
        float radio = Radio(x,yr);
        xFinal = x;
        yFinal = y;
        float Precision=(float) Math.abs ( (long)   (((x-xActual)/(xActual)) *100) );                           // Porcentaje de precisin
        if(((yr-radio)<=y) && (Precision>1)) Fin(x,y,xActual,yActual);          // Hasta que la precisin
        if(((yr-radio)>y) && (Precision>1)) Fin(xAnterior,yAnterior,x,y);       // sea 1%
    }
    public SortedMap Obstruct(){
     TreeMap Obst = new TreeMap();   
     Obst =(TreeMap) Perfil.subMapC(new Float(P_Inicio),new Float(P_Fin));
     Obst.put(new Float(xInicial),new Float(yInicial));
     Obst.put(new Float(xFinal),new Float(yFinal));
     return Obst;
    }
    
    public boolean isObstructed(){
     boolean O;   
        if (Obst.isEmpty()) O=false;
        else O=true;
     return O;
    } 
    public SortedMap getEllipse(){
    Ellipse.put("U",UEllipse);
	Ellipse.put("L",LEllipse);
    
    return Ellipse;
    }
     public float getfrec(){return frecuencia;  
     }
    
    private SimpleComplex LowerPoint(float radio, Recta recta, float xp){
		float angle = recta.angle();
		SimpleComplex Result = new SimpleComplex();
		SimpleComplex Radius = new SimpleComplex(radio,(float)(angle+3*Math.PI/2),"P");
		SimpleComplex Base = new SimpleComplex(xp,recta.get_y(xp),"C"); 
	
		Result =Base.Add(Radius);
    return Result;	 
    }
	
	private SimpleComplex UpperPoint(float radio, Recta recta, float xp){
		float angle = recta.angle();
		SimpleComplex Result = new SimpleComplex();
		SimpleComplex Radius = new SimpleComplex(radio,(float)(angle+Math.PI/2),"P");
		SimpleComplex Base = new SimpleComplex(xp,recta.get_y(xp),"C"); 
	
		Result =Base.Add(Radius);
	return Result;	 
	}     
     
     
    public float P_Inicio, P_Fin;
    private RadioLink Antenas;
    private TopoProfile Perfil;
    private float xA,xB,yA,yB;          // Posicin de las Antenas
    private float xInicial, yInicial;   // Inicio de Obstruccin
    private float xFinal, yFinal;       // Fin de la Obstruccin
    private float lambda;
    private float frecuencia;
    private Math Calc;
    private Recta recta;
    private TreeMap Ellipse,LEllipse,UEllipse,Obst;
    
}
    
