import java.awt.Color;
import java.awt.Graphics2D;

import javax.swing.JPanel;


public class Graphic extends JPanel{
    
    public Graphic(){super();}
    /** Creates a new instance of Class */
    public void StartUp(int heigthin, int widthin,float xscalein,float yscalein) {
        xscale=xscalein;
        yscale=yscalein;
        
        Height=heigthin;
        width=widthin;
        IOMap Lellipse=new IOMap();
        IOMap Uellipse=new IOMap();
        IOMap Topo=new IOMap();
        IOMap P=new IOMap();  
        IOMap PLellipse=new IOMap();
        IOMap PUellipse=new IOMap();
        IOMap PTOpo=new IOMap();
        IOMap PP=new IOMap();
    }
    
    public void ShowAll(RadioLink Antennas,TopoProfile TProf, IOMap Ellipse){
    
    Rk = (float) TProf.getRk();
    beta0 = (float) (TProf.finalP()).getIm();
    beta1 =(float) (TProf.initP()).getIm();
    Uellipse = (IOMap) Ellipse.get("U");
	Lellipse = (IOMap) Ellipse.get("L");
    
    
    
	dobst=false;
	dearth =true;
	dtopo =false;
	dzone =false;
	repaint();
    
    ShowZone(Antennas);
    ShowTopo(TProf);
    }
      
    
    public void ShowZone(RadioLink Antennas){
        FTreeMap Bases = new FTreeMap();
        Bases=Antennas.Bases();
        antenna1x = ((Float) Antennas.firstKeyC()).floatValue();
        antenna1y = ((Float) Antennas.getC(Antennas.firstKeyC())).floatValue();
        antenna2x = ((Float) Antennas.lastKeyC()).floatValue();
        antenna2y = ((Float) Antennas.getC(Antennas.lastKeyC())).floatValue();
        
        bantenna1x =((Float) Bases.firstKeyC()).floatValue();
        bantenna1y = ((Float) Bases.getC(Antennas.firstKeyC())).floatValue();
        bantenna2x = ((Float) Bases.lastKeyC()).floatValue();
        bantenna2y = ((Float) Bases.getC(Antennas.lastKeyC())).floatValue();
        
        pantenna1x = f2p(antenna1x,"x");
        pantenna1y = f2p(antenna1y,"y");
        pantenna2x = f2p(antenna2x,"x");
        pantenna2y = f2p(antenna2y,"y");
        
        pbantenna1x = f2p(bantenna1x,"x");
        pbantenna1y = f2p(bantenna1y,"y");
        pbantenna2x = f2p(bantenna2x,"x");
        pbantenna2y = f2p(bantenna2y,"y");
        
        PUellipse.clear();
        PLellipse.clear();
        
        PUellipse=f2p(Uellipse);
        PLellipse=f2p(Lellipse);
		dobst=false;
		dearth =false;
		dtopo =false;
		dzone =true;
		repaint();
                        
    
    }
 private void DrawZone (Graphics2D G){
        G.setColor(new Color(255,0,0));
        G.drawLine(pbantenna1x,pbantenna1y,pantenna1x,pantenna1y);
        G.drawLine(pbantenna2x,pbantenna2y,pantenna2x,pantenna2y);
        G.setColor(new Color(255,0,0));
        G.drawPolyline(PUellipse.intKeyArray(),PUellipse.intValueArray(),PUellipse.size());
        G.drawPolyline(PLellipse.intKeyArray(),PLellipse.intValueArray(),PLellipse.size());
        
    }
  
    
    
    public void ShowTopo(TopoProfile TProf){
        Topo = (IOMap)TProf.CMap();
        PTopo=f2p(Topo);             
		dobst=false;
		dearth =false;
		dtopo =true;
		dzone =false;
		repaint();
    }
    
      private void DrawTopo(Graphics2D G){
        G.setColor(new Color(139,69,19));
        G.drawPolyline(PTopo.intKeyArray(),PTopo.intValueArray(),PTopo.size());
    }  
    
    
    public void ShowObsctruct(IOMap inMap){
        int size= inMap.size();
        PP = f2p(inMap);
		
		dobst=true;
		dearth =false;
		dtopo =false;
		dzone =false;
		repaint();	
    }

    private void DrawObstruct(Graphics2D G){
        G.setColor(new Color (255,69,0));
        G.fillPolygon(PP.intKeyArray(),PP.intValueArray(),PP.size());
    }
    
    
    
    
    private void DrawEarth (Graphics2D G){
        
        G.setColor(new Color(139,69,19));
        float Dx,Dy,angle0,angle1,h;
        
        Dx = (float)(Rk*(0.5-Math.sin(beta0)));
        Dy = (float)(Rk*(0.5-Math.cos(beta0)));
        
        angle0= (float)((180/Math.PI)*beta0);
        angle1= (float)((180/Math.PI)*beta1);
        
        h = Rk/1000;
        
        G.drawArc(f2p(Dx,"x"),f2p(Dy,"y"),f2p(2*Rk,"x"),f2p(2*h,"y"),Math.round(angle0),Math.round(angle1));
    }
    

	private void paint(Graphics2D G){
	G.setBackground(new Color(255,255,255));	
	if(dobst)  this.DrawObstruct(G);
	if(dearth) this.DrawEarth(G);
	if(dtopo)  this.DrawTopo(G);
	if(dzone)  this.DrawZone(G);
	
	dobst=true;
	dearth =true;
	dtopo =true;
	dzone =true;	
		
	}
        

     //data to pixels
 
    private int f2p(float in,String coord){
        int result=-5;
        if(coord.equals("x")){
             result = f2p(in,"x",0);
             
        }
        if(coord.equals("y")){
            result = f2p(in,"y",0);
            
        }
        return result;
    }
    
    private int f2p(float in,String coord,int offset){
        int result=-5;
        if(coord.equals("x")){
             result= Math.round((in/xscale)*width)+offset;
        }
        if(coord.equals("y")){
            int Yy= Math.round((in/yscale)*Height)+offset;
            result= Height-Yy;
        }
        return result;
    }
   
   
    private int[] f2p(float[] fdata, String Coord){
      int[] result = new int[fdata.length];
        
        for(int jj=0;jj<fdata.length;jj++)
                result[jj] = f2p(fdata[jj],Coord);
                
               return result;
    }    
   private IOMap f2p(IOMap data){
        IOMap result = new IOMap();
        float[] x =new float[data.size()];
        float[] y=new float [data.size()];
        int[] xf =new int[data.size()];
        int[] yf=new int[data.size()];
        
        x= data.KeyArray();
        y= data.ValueArray();
        
        xf=f2p(x,"x");
        yf=f2p(y,"y");
        
        for(int i=0;i<xf.length;i++)
         result.put(new Integer(xf[i]),new Integer(yf[i]));   
            
        
      return result; 
   } 
   
   

        
        
    
    
    private IOMap Lellipse,Uellipse,Topo,P;  
    private IOMap PLellipse,PUellipse,PTopo, PP;
    private int Height,width;    
    private float antenna1x,antenna1y,antenna2x,antenna2y;
    private float bantenna1x,bantenna1y,bantenna2x,bantenna2y;
    private int pantenna1x,pantenna1y,pantenna2x,pantenna2y;
    private int pbantenna1x,pbantenna1y,pbantenna2x,pbantenna2y;
    public float xscale,yscale;
    private float Rk,beta0,beta1;
    private boolean dobst,dearth,dtopo,dzone;
   
    private Math Calc;
}
