
import java.lang.Math;
import java.lang.Float;
//import java.util.Set;
//import java.util.SortedSet;
//import java.util.TreeSet;
import java.util.Vector;
//import java.util.Collections;

public class TopoProfile extends FTreeMap {
    
    private double k; 
    private double Rk;
    private static double Ro = 6385.4;      // Radio de la Tierra
    private double alpha;
    private SimpleComplex Po, Pn,Correction;  
    private double betao,xo;    
    //private FTreeMap Corrected;
    private Math  Calc;
    
    /** Creates a new instance of TopoProfile */
    public TopoProfile() {
        super();
    }
    
    public void setk(double K){
        k=K;
        Rk=Ro*k;
              
        this.CorrectMap();       
        
    }
    
  public void setk(double K, RadioLink RL){
        this.setk(k);
        this.CorrectMap();
        this.CorrectAntennas(RL);
   //     if(!RL.isEmpty) this.CorrectAntennas();
    }
    
    
    
    public void CorrectMap() {
        
            super.clearC();
            SimpleComplex Po,Pn;
            
            xo = ((Float)( super.firstKey())).doubleValue();
            double xn = ((Float)( super.lastKey())).doubleValue();
            
            alpha= (xn-xo)/Ro;
            double betan= (Math.PI -alpha)/2;
            betao= alpha+betan;
            
            Po=new SimpleComplex(Rk,betao,"P");
            Pn=new SimpleComplex(Rk,betan,"P");
            
           
            Correction = new SimpleComplex(((Po.getReal()-Pn.getReal())/2) , Pn.getIm(),"C");
              
            
            
            super.putC(new Float(Po.getReal()-Correction.getReal()),new Float((Po.getIm()/1000)-Correction.getIm()));
            super.putC(new Float(Pn.getReal()-Correction.getReal()),new Float((Pn.getIm()/1000)-Correction.getIm()));
            
            //SortedSet X = Collections.synchronizedSortedSet(new TreeSet()); 
            Vector VX =new Vector ();
        
            //X=(TreeSet) super.keySet();
             VX= super.keySetV();
        
            
            int first =VX.indexOf(VX.firstElement()) ;
            int last  =VX.indexOf(VX.lastElement());
            
            for(int i= (first+1) ;i <last;i++){
                double xi = ((Float)VX.elementAt(i)).doubleValue();
                double yi = ((Float)super.get(VX.elementAt(i))).doubleValue();
                
                double betai = betao - ((xi-xo)/Ro);
                double Mi    = k*(Ro+(yi/1000));
                
                SimpleComplex Pi = new SimpleComplex(Mi,betai,"P");
                
                double xRi = Pi.getReal()-Correction.getReal();
                double yRi = 1000*Pi.getIm()-Correction.getIm();
                
                
                super.putC(new Float(xRi),new Float(yRi));
              
            }
    }
    
    public void CorrectAntennas(RadioLink RL){
           // SortedSet X = Collections.synchronizedSortedSet(new TreeSet()); 
            Vector VX =new Vector ();
            Vector VXB=new Vector();
            /*corrects the antennas*/
            
            /*in first place, lets clear ther previous modified antennas map*/
            RL.clearC();
            RL.clearCBases();

            //X=(TreeSet) RL.keySet();
            //boolean dummy = VX.addAll(X);
            VX  = RL.keySetV();
            VXB = RL.keySetVB();
            
            int first =VX.indexOf(VX.firstElement()) ;
            int last  =VX.indexOf(VX.lastElement());
            
            for(int i= first ;i <(last+1);i++){
                /*antennas*/
                double xi = ((Float)VX.elementAt(i)).doubleValue();
                double yi = ((Float)RL.get(VX.elementAt(i))).doubleValue();
                
                double betai = betao - ((xi-xo)/Ro);
                double Mi    = k*(Ro+(yi/1000));
                
                SimpleComplex Pi = new SimpleComplex(Mi,betai,"P");
                
                double xRi = Pi.getReal()-Correction.getReal();
                double yRi = 1000*Pi.getIm()-Correction.getIm();
                
                RL.putC(new Float(xRi),new Float(yRi));
                
                /*bases*/
                double xiB = ((Float)VXB.elementAt(i)).doubleValue();
                double yiB = ((Float)RL.getB(VXB.elementAt(i))).doubleValue();
                
                double betaiB = betao - ((xiB-xo)/Ro);
                double MiB    = k*(Ro+(yiB/1000));
                
                SimpleComplex PiB = new SimpleComplex(MiB,betaiB,"P");
                
                double xRiB = PiB.getReal()-Correction.getReal();
                double yRiB = 1000*PiB.getIm()-Correction.getIm();
                
                RL.putCBases(new Float(xRiB),new Float(yRiB));
              
            }
            
            
            
            
   }
/*access alpha, k, Correction (requested by graphical Objects*/

public double getalpha(){return alpha;}
public double getk(){return k;}
public double getRk(){return Rk;}
public SimpleComplex getCorr(){return Correction;}
public SimpleComplex initP(){ return Po;}
public SimpleComplex finalP(){ return Pn;}
   
    
    
}
